Hooks:PostHook( MenuSceneManager, "set_scene_template", "bprc_menuscene_set_scene_template", function(self, ...)
	self._disable_rotate = true
	self._bprc_disable_rotate = not BlackmarketPreviewRotationControl:IsAutomaticRotationEnabled()
	if BlackmarketPreviewRotationControl:IsShakerDisabled() then 
		self._shaker:stop_all()
	end
	
	local default_rotation = BlackmarketPreviewRotationControl:GetDefaultRotation()
	
	self._item_yaw = default_rotation:yaw()
	self._item_pitch = default_rotation:pitch()
	self._item_roll = default_rotation:roll()
	self._bprc_disable_item_updates = false --self._disable_item_updates
	self._disable_item_updates = true --prevent original item rotation code from executing
end)

Hooks:PostHook(MenuSceneManager,"update","bprc_menuscene_update",function(self,t,dt)

	if self._item_unit and self._item_unit.unit and not self._bprc_disable_item_updates and not self._item_grabbed then
		if not managers.blackmarket:currently_customizing_mask() then 
			if not self._bprc_disable_rotate then
				self._item_yaw = (self._item_yaw + BlackmarketPreviewRotationControl:GetYawSpeed() * dt) % 360
				self._item_pitch = (self._item_pitch + BlackmarketPreviewRotationControl:GetPitchSpeed() * dt) % 360
				self._item_roll = (self._item_roll + BlackmarketPreviewRotationControl:GetRollSpeed() * dt) % 360
			end
		end

--		self._item_pitch = math.lerp(self._item_pitch, 0, 10 * dt)
--		self._item_roll = math.lerp(self._item_roll, 0, 10 * dt)

		mrotation.set_yaw_pitch_roll(self._item_rot_temp, self._item_yaw, self._item_pitch, self._item_roll)
		mrotation.set_zero(self._item_rot)
		mrotation.multiply(self._item_rot, self._camera_object:rotation())
		mrotation.multiply(self._item_rot, self._item_rot_temp)
		mrotation.multiply(self._item_rot, self._item_rot_mod)
		self._item_unit.unit:set_rotation(self._item_rot)

		local new_pos = self._item_rot_pos + self._item_offset:rotate_with(self._item_rot)

		self._item_unit.unit:set_position(new_pos)
		self._item_unit.unit:set_moving(2)
	end
end)